//	GIF֤Servletǥ
//	Version 0.10	2000.07.18
//	Version 0.11	2000.07.19		Ϣ³reloadб
//	Version 0.12	2000.07.20-		GIFե뤫ɤ߹
//	Version 0.12a	2000.08.13		
//
//	Servlet Counter "GifImage"
//	Copyright (C) CONFLICT 2000.  All rights reserved.

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 *	GIF᡼ȤäServletǥ󥿤Ǥ
 *	GifCounterSetting.properties顢ɤ߹ߤޤ<BR>
 *	㡧
 *	<PRE>
 *	    CounterFileDir=./
 *	    GifFileDir=./
 *	    IgnoreReload=false
 *	    EnableLog=true
 *	</PRE>
 *	<CODE>CounterFileDir</CODE>ˤϡ󥿥ǡե֤ǥ쥯ȥ
 *	ꤷޤ<BR>
 *	<CODE>GifFileDir</CODE>ˤϡGIFեΥǥ쥯ȥ
 *	ꤷޤGIFեϡ"0.gif""9.gif"Ȥե̾ǡ
 *	ǥ쥯ȥ֤Ƥ<BR>
 *	<CODE>IgnoreReload</CODE>ˤϡ<CODE>true</CODE><CODE>false</CODE>
 *	ꤷޤ<CODE>true</CODE>ꤹȡƱۥȤΥɤ̵
 *	ޤ<BR>
 *	<CODE>EnableLog</CODE>ˤϡ<CODE>true</CODE><CODE>false</CODE>
 *	ꤷޤ<CODE>true</CODE>ꤹȡServlet EngineΥ󥽡
 *	åɽޤ
 *
 *	@author	դ꤯
 */
public class GifCounter extends HttpServlet {
	//	󥹥ѿ
	private String gifDir = "./";			//	GIF᡼Υǥ쥯ȥ
	private String datDir = "./";			//	󥿥եΥǥ쥯ȥ
	private boolean ignoreReload = true;	//	ƱۥȤΥ̵
	private boolean logging = false;				//	ν
	
	private GifImage[] digits;						//	ƷGIF᡼
	private Hashtable counterValueHash = null;		//	ʣ󥿤ͤϿ
	private Hashtable lastHostHash = null;			//	ǽۥIP
	
	//	ǥեȥ󥹥ȥ饯
	/**
	 *	GifCounterۤޤ
	 */
	public GifCounter() {
		//	꥽ɤ߹
		ResourceBundle rb = null;
		gifDir = null;
		datDir = null;
		try {
			rb = ResourceBundle.getBundle("GifCounterSetting");
			gifDir       = rb.getString("GifFileDir");
			datDir       = rb.getString("CounterFileDir");
			ignoreReload = rb.getString("IgnoreReload").equals("true");
			logging      = rb.getString("EnableLog").equals("true");
		}
		catch(MissingResourceException e) {
			System.out.println("GifCounter: Cannot found resource file.");
		}
		
		//	
		counterValueHash = new Hashtable();
		lastHostHash = new Hashtable();
		
		//	GIFեɤ߹
		digits = new GifImage[10];
		for(int i = 0; i < 10; i++) {
			String fln = gifFileName(i);
			try {
				digits[i] = new GifImage(fln);
			}
			catch(Exception e) {
				System.out.println("GifCounter: Exception occurs in loading " 
																+ fln + ".");
				e.printStackTrace();
				System.exit(1);
			}
		}
		
		if(logging) {
			System.out.println("GifCounter: Instance created.");
		}
	}
	
	//	ѥե̾
	private String counterFileName(String name) {
		return datDir + "GifCounter_" + name + ".txt";
	}
	
	//	GIFѥե̾
	private String gifFileName(int num) {
		return gifDir + num + ".gif";
	}
	
	//	󥿤βû¾Ԥʤ
	private synchronized int 
	updateCounter(HttpServletRequest req, String name) {
		int value = getCounterValue(name);
		
		if(logging) {
			System.out.println("GifCounter: Count up " + name + ". ");
		}
		if(ignoreReload) {
			String addr = req.getRemoteHost();
			String last = (String)lastHostHash.get(name);
			if(logging) {
				System.out.println("GifCounter: Host is now " + 
													addr + ", last " + last);
			}
			if(addr.equals(last)) {					//	Ʊۥ?
				return value;
			}
			lastHostHash.put(name, addr);
		}
		
		value++;
		setCounterValue(name, value);
		return value;
	}
	
	//	󥿼
	private int getCounterValue(String name) {
		//	Ǥɤ߹ߺѤߤʤ顢ͤ򤽤Τޤ޻Ȥ
		Integer value_obj = (Integer)counterValueHash.get(name);
		
		if(value_obj == null) {
			//	ե뤫οͼ
			try {
				BufferedReader br = 
					new BufferedReader(new FileReader(counterFileName(name)));
				
				String s = br.readLine();
				value_obj = new Integer(s);
				
				br.close();
			}
			catch(FileNotFoundException e) {
				//	ե뤬ʤͤ0
				value_obj = new Integer(0);
			}
			catch(Exception e) {
				//	ͽʤ顼
				e.printStackTrace();
				value_obj = new Integer(0);
			}
			
			//	󥢥ƵϿ
			counterValueHash.put(name, value_obj);
		}
		
		return value_obj.intValue();
	}
	
	//	󥿹
	private void setCounterValue(String name, int value) {
		Integer value_obj = new Integer(value);
		
		//	ĥФƤ⤤褦ˡեؽ
		try {
			BufferedWriter bw = 
					new BufferedWriter(new FileWriter(counterFileName(name)));
			
			bw.write(Integer.toString(value));
			bw.newLine();
			
			bw.close();
		}
		catch(Exception e) {
			e.printStackTrace();
		}
		
		//	ǡ⹹
		counterValueHash.put(name, value_obj);
	}
	
	//	POST᥽å
	/**
	 *	ѥ᡼<CODE>NAME</CODE>ǻꤵ줿̾Υ󥿤ä
	 *	ѥ᡼<CODE>DIGITS</CODE>ǻꤵ줿GIF᡼
	 *	쥹ݥ󥹤Ȥ֤ޤ
	 *	@param	request		httpꥯȡ
	 *	@param	pesponse	http쥹ݥ󥹡
	 *	@throws	IOException
	 *			ϥ顼ȯ硣
	 *	@throws	ServletException
	 *			POSTԤʤʤ硣
	 */
	public void doPost(
		HttpServletRequest request, HttpServletResponse response)
		throws IOException, ServletException 
	{
		if(logging) {
			System.out.println("GifCounter: POST.");
		}
		doGet(request, response);
	}
	
	//	GET᥽å
	/**
	 *	ѥ᡼<CODE>NAME</CODE>ǻꤵ줿̾Υ󥿤ä
	 *	ѥ᡼<CODE>DIGITS</CODE>ǻꤵ줿GIF᡼
	 *	쥹ݥ󥹤Ȥ֤ޤ
	 *	@param	request		httpꥯȡ
	 *	@param	pesponse	http쥹ݥ󥹡
	 *	@throws	IOException
	 *			ϥ顼ȯ硣
	 *	@throws	ServletException
	 *			GETԤʤʤ硣
	 */
	public void doGet(
		HttpServletRequest request, HttpServletResponse response)
		throws IOException, ServletException 
	{
		if(logging) {
			System.out.println("GifCounter: GET.");
		}
		
		//	ѥ᡼ܸб
		String name = request.getParameter("NAME");				//	̾
		if(name == null) {
			name = "default";
		}
		
		String dig_num_s = request.getParameter("DIGITS");		//	
		int dig_num;
		if(dig_num_s == null) {
			dig_num = 6;
		}
		else {
			try {
				dig_num = Integer.parseInt(dig_num_s);
			}
			catch(NumberFormatException e) {
				dig_num = 6;
			}
		}
		if(dig_num < 1 || dig_num > 10) {
			dig_num = 6;
		}
		
		//	󥿤ͼȹ
		int value = updateCounter(request, name);
		
		//	Ϥʸ򥼥ղäƺ
		String s = "000000000" + Integer.toString(value);
		s = s.substring(s.length() - dig_num);
		
		//	᡼
		Vector v = new Vector();
		byte[] image = null;
		
		try {
			for(int i = 0; i < s.length(); i++) {
				int d = Integer.parseInt(s.substring(i, i + 1));
				
				GifImage image1 = (GifImage)digits[d].clone();
				image1.parseImage();
				v.add(image1);
			}
			
			image = GifCat.concatImage(v.elements());
		}
		catch(Exception e) {
			e.printStackTrace();
			
			response.setContentType("text/html");
			PrintWriter out = response.getWriter();
			
			out.println("<html><head><title>ERROR</title></head>");
			out.println("<body><h1>Internal servlet error.</h1></body>");
			out.println("</html>");
			
			System.exit(1);
		}
		
		//	饤Ȥإ᡼
		response.setContentType("image/gif");
		DataOutputStream out = 
				new DataOutputStream(response.getOutputStream());
		out.write(image);
		out.close();
	}
}
